"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
// https://gist.github.com/aderaaij/a6b666bf756b2db1596b366da921755d
var getComputedTranslateXY = function (el) {
    if (!window.getComputedStyle)
        return;
    var style = getComputedStyle(el);
    var transform = style.transform || style.webkitTransform;
    var mat = transform.match(/^matrix3d\((.+)\)$/);
    if (mat)
        return parseFloat(mat[1].split(', ')[13]);
    mat = transform.match(/^matrix\((.+)\)$/);
    return [mat ? parseFloat(mat[1].split(', ')[4]) : 0, mat ? parseFloat(mat[1].split(', ')[5]) : 0];
};
var Transformer = /** @class */ (function (_super) {
    __extends(Transformer, _super);
    function Transformer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.srcRef = React.createRef();
        _this.getOffset = function () {
            var _a = _this.props, transformed = _a.transformed, destRef = _a.destRef;
            var dx = 0;
            var dy = 0;
            if (transformed && _this.srcRef.current && destRef) {
                var rect = _this.srcRef.current.getBoundingClientRect();
                var destinationRect = destRef.getBoundingClientRect();
                var transform = getComputedTranslateXY(_this.srcRef.current);
                dx = destinationRect.left - rect.left + transform[0];
                dy = destinationRect.top - rect.top + transform[1];
            }
            _this.srcRef.current.style.transform = "translate(" + dx + "px, " + dy + "px)";
        };
        _this.setTransistion = function () {
            _this.srcRef.current.style.transition = "transform " + _this.props.transition + "ms";
        };
        return _this;
    }
    Transformer.prototype.componentDidMount = function () {
        var _this = this;
        if (this.props.transformed && this.srcRef.current) {
            this.srcRef.current.style.opacity = '0';
            this.srcRef.current.style.transition = 'transform 0ms';
            this.getOffset();
        }
        window.setTimeout(function () {
            if (_this.srcRef.current) {
                _this.srcRef.current.style.opacity = '1';
                _this.setTransistion();
            }
        });
    };
    Transformer.prototype.componentDidUpdate = function (nextProps) {
        var transition = nextProps.transition;
        if (this.props.transition !== transition) {
            this.setTransistion();
        }
        this.getOffset();
    };
    Transformer.prototype.render = function () {
        return React.createElement("div", { ref: this.srcRef }, this.props.children);
    };
    Transformer.defaultProps = {
        transition: 0,
    };
    return Transformer;
}(React.Component));
exports.default = Transformer;
